#include <iostream>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <sstream>
#include <string>
#include <direct.h>
#include <unistd.h>
#define GetCurrentDir _getcwd
using namespace std;

void removeForbiddenChar(string* s)
{
    string::iterator it;

    string illegalChars = "\\/:?\"<>|!";
    for (it = s->begin() ; it < s->end() ; ++it){
        bool found = illegalChars.find(*it) != string::npos;
        if(found){
            *it = ' ';
        }
    }
}

int main()
{
    FILE * pFile;
    char mystring[150];
    string firststring ("#EXTM3U");
    string urlstring ("http");
    stringstream tmp;
    char *p1, *p2;
    char cCurrentPath[FILENAME_MAX];
    char *fulPath1;
    char *fulPath2;
    char *m3uPath;
    string whitespaces (" \t\f\v\n\r");
    size_t found;


    if (!GetCurrentDir(cCurrentPath, sizeof(cCurrentPath)))
    {
        return errno;
    }
    string path(cCurrentPath);

    m3uPath = new char [13+path.size()];
    strcpy(m3uPath, cCurrentPath);
    strcat (m3uPath,"\\Default.m3u");

    pFile = fopen (m3uPath, "r");
    if (pFile == NULL) perror ("Error opening file");
    else
    {
        while (!feof(pFile))
        {
            if (fgets (mystring , 100 , pFile)!=NULL)
            {
                std::string line(mystring);
                if (line.find(firststring)!=string::npos)
                    cout<<"Starting to rename from "<<m3uPath<<"\r\n";
                else
                    if (line.find(urlstring)==string::npos)
                    {
                        string tempname (line.substr(line.find_first_of(",")+1));
                        found=tempname.find_last_not_of(whitespaces);
                        if (found!=string::npos)
                            tempname.erase(found+1);
                        else
                            tempname.clear();
                        removeForbiddenChar(&tempname);
                        cout<<"new name: "<<tempname<<".mp3; ";
                        p1 = new char [tempname.size()+1];
                        strcpy(p1, tempname.c_str());
                        fulPath1 = new char [tempname.size()+2+path.size()];
                        strcpy(fulPath1, cCurrentPath);
                        strcat (fulPath1,"\\");
                        strcat (fulPath1,p1);
                        strcat (fulPath1,".mp3");
                    }
                    else
                    {
                        string tempurl (line.substr(line.find_last_of("/")+1));
                        found=tempurl.find_last_not_of(whitespaces);
                        if (found!=string::npos)
                            tempurl.erase(found+1);
                        else
                            tempurl.clear();
                        cout<<"old name: "<<tempurl<<"\r\n";
                        p2 = new char [tempurl.size()+1];
                        strcpy(p2, tempurl.c_str());
                        fulPath2 = new char [tempurl.size()+2+path.size()];
                        strcpy(fulPath2, cCurrentPath);
                        strcat (fulPath2,"\\");
                        strcat (fulPath2,p2);
                        if (rename(fulPath2,fulPath1)!=0)
                            perror ("Error renaming file");
                        usleep(100000);
                        delete []p1;
                        delete []p2;
                    }
            }
        }
        fclose (pFile);
   }
   cout<<"Rename complited, press any key to exit";
   getch();
   return 0;
}
